#pragma once

#OnAutoItStartRegister __LogiGKey_Init


Func __LogiGKey_Init()
	Local Const $tagLogiGkeyCBContext = "ptr callback; ptr context"
	Global $g_gkey_dll = DllOpen("LogitechGkey.dll")

	Local $context = DllStructCreate($tagLogiGkeyCBContext)
;~ 	Global $g_gkey_callback = DllCallbackRegister("_Callback", "none:cdecl", "dword;wstr;ptr")
;~ 	$context.callback = DllCallbackGetPtr($g_gkey_callback)
	$context.callback = 0
	$context.context = 0
	Local $ret = DllCall($g_gkey_dll, "BOOL:cdecl", "LogiGkeyInit", "ptr", DllStructGetPtr($context))
	If( IsArray($ret) ) Then
		OnAutoItExitRegister("_LogiGKey_Shutdown")
		Return( 1 )
	EndIf
	Return( 0 )
EndFunc

Func _LogiGkey_IsKbdPressed($keynumber, $modenumber)
	Local $ret = DllCall($g_gkey_dll, "BOOL:cdecl", "LogiGkeyIsKeyboardGkeyPressed", "int", $keynumber, "int", $modenumber)
	Return( $ret[0] )
EndFunc

Func _LogiGkey_GetFriendlyKbdString($keynumber, $modenumber)
	Local $ret = DllCall($g_gkey_dll, "wstr:cdecl", "LogiGkeyGetKeyboardGkeyString", "int", $keynumber, "int", $modenumber)
	Return( $ret[0] )
EndFunc

Func _LogiGkey_GetFriendlyMouseString($keynumber)
	Local $ret = DllCall($g_gkey_dll, "wstr:cdecl", "LogiGkeyGetMouseButtonString", "int", $keynumber)
	Return( $ret[0] )
EndFunc

Func _LogiGkey_IsMousePressed($keynumber)
	Local $ret = DllCall($g_gkey_dll, "BOOL:cdecl", "LogiGkeyIsMouseButtonPressed", "int", $keynumber)
	Return( $ret[0] )
EndFunc

Func _LogiGKey_Shutdown()
	OnAutoItExitUnRegister("_LogiGKey_Shutdown")
	DllCall($g_gkey_dll, "none:cdecl", "LogiGkeyShutdown")
;~ 	DllCallbackFree($g_gkey_callback)
	DllClose($g_gkey_dll)
	$g_gkey_dll = -1
EndFunc




